{-# LANGUAGE OverloadedStrings #-}

module Jon.Main
    ( main
    , runFunction
    , runQuery
    , runIns
    ) where

import Database.Beam
import Database.Beam.Postgres
import System.Environment

import qualified Data.ByteString.Char8 as BS8

main :: IO ()
main = pure ()

runQuery
    :: (FromBackendRow Postgres (QExprToIdentity e), Projectible Postgres e)
    => Q Postgres db QBaseScope e
    -> IO [QExprToIdentity e]
runQuery q = do
    pass <- getEnv "JON_PASS"
    conn <- connectPostgreSQL $ BS8.pack $ "host=localhost dbname=garfield password=" ++ pass
    runBeamPostgresDebug putStrLn conn $ runSelectReturningList $ select q

runIns
    :: SqlInsert Postgres table
    -> IO ()
runIns i = do
    pass <- getEnv "JON_PASS"
    conn <- connectPostgreSQL $ BS8.pack $ "host=localhost dbname=garfield password=" ++ pass
    runBeamPostgresDebug putStrLn conn $ runInsert i

runFunction
    :: (Connection -> IO a)
    -> IO a
runFunction f = do
    pass <- getEnv "JON_PASS"
    conn <- connectPostgreSQL $ BS8.pack $ "host=localhost dbname=garfield password=" ++ pass
    f conn
